total_N=10;
total_R=20;

ll_bexp_true=zeros(total_N,total_R);
ll_bexp_KDE=zeros(total_N,total_R);
ll_bexp_GMM=zeros(total_N,total_R);
ll_bexp_NP=zeros(total_N,total_R);
ll_nexp_true=zeros(total_N,total_R);
ll_nexp_KDE=zeros(total_N,total_R);
ll_nexp_GMM=zeros(total_N,total_R);
ll_nexp_NP=zeros(total_N,total_R);
ll_texp_true=zeros(total_N,total_R);
ll_texp_KDE=zeros(total_N,total_R);
ll_texp_GMM=zeros(total_N,total_R);
ll_texp_NP=zeros(total_N,total_R);
nnz_bexp=zeros(total_N,total_R);
nnz_nexp=zeros(total_N,total_R);
nnz_texp=zeros(total_N,total_R);



for i=1:10
    for j=1:20
        ki=i*100;
	[loglik,nnz]=extractlogliknr(ki,j,'../bexp/gmm/','_bexp.den');
	ll_bexp_true(i,j)=loglik(1);
	ll_bexp_KDE(i,j)=loglik(2);
	ll_bexp_GMM(i,j)=loglik(3);
	ll_bexp_NP(i,j)=loglik(4);
	nnz_bexp(i,j)=nnz;
	
        [loglik,nnz]=extractlogliknr(ki,j,'../nexp/','_rexp.den');
	ll_nexp_true(i,j)=loglik(1);
	ll_nexp_KDE(i,j)=loglik(2);
	ll_nexp_GMM(i,j)=loglik(3);
	ll_nexp_NP(i,j)=loglik(4);
	nnz_nexp(i,j)=nnz;

	[loglik,nnz]=extractlogliknr(ki,j,'../texp/','_texp.den');
	ll_texp_true(i,j)=loglik(1);
	ll_texp_KDE(i,j)=loglik(2);
	ll_texp_GMM(i,j)=loglik(3);
	ll_texp_NP(i,j)=loglik(4);
	nnz_texp(i,j)=nnz;

    end
end

h1=figure(1);
hold on;
x=100:100:1000;
boxplot(ll_bexp_true','symbol','','colors','k','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_bexp_true'),'k-','LineWidth',2);

boxplot(ll_bexp_KDE','symbol','','colors','b','widths',0.4);
set(gca,'XTickLabel',{' '}); 
plot(median(ll_bexp_KDE'),'b-.','LineWidth',2);

boxplot(ll_bexp_GMM','symbol','','colors','g','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_bexp_GMM'),'g:','LineWidth',2);

boxplot(ll_bexp_NP','symbol','','colors','r','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_bexp_NP'),'r--','LineWidth',2);

xlabel('n');
ylabel('Out-of-sample log-likelihood');

set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10]);
set(gca,'XTickLabel',{'100','200','300','400','500','600','700','800','900','1000'})
    
title('Fitting Mixed-Normal Distribution');

lh=legend('True','KDE','GMM','NP');
set(lh,'Location','SouthEast');

hold off;
save2pdf('bexp_ll.pdf',h1,300);


h3=figure('visible','off');
hold on;
x=100:100:1000;
boxplot(ll_texp_true','symbol','','colors','k','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_texp_true'),'k-','LineWidth',2);

boxplot(ll_texp_KDE','symbol','','colors','b','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_texp_KDE'),'b-.','LineWidth',2);

boxplot(ll_texp_GMM','symbol','','colors','g','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_texp_GMM'),'g:','LineWidth',2);

boxplot(ll_texp_NP','symbol','','colors','r','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_texp_NP'),'r--','LineWidth',2);

xlabel('n');
ylabel('Out-of-sample log-likelihood');

axis([0.5 10.5 -167500 -158000]);
set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10]);
set(gca,'XTickLabel',{'100','200','300','400','500','600','700','800','900','1000'})
    
title('Fitting t Distribution, df=6');

lh=legend('True','KDE','Gaussian','NP');
set(lh,'Location','SouthEast');

hold off;
save2pdf('texp_ll.pdf',h3,300);

h2=figure('visible','off');
hold on;
x=100:100:1000;
boxplot(ll_nexp_true','symbol','','colors','k','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_nexp_true'),'k-','LineWidth',2);

boxplot(ll_nexp_KDE','symbol','','colors','b','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_nexp_KDE'),'b-.','LineWidth',2);

boxplot(ll_nexp_GMM','symbol','','colors','g','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_nexp_GMM'),'g:','LineWidth',2);

boxplot(ll_nexp_NP','symbol','','colors','r','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(ll_nexp_NP'),'r--','LineWidth',2);


xlabel('n');
ylabel('Out-of-sample log-likelihood');

set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10]);
set(gca,'XTickLabel',{'100','200','300','400','500','600','700','800','900','1000'})
    
title('Fitting normal distribution');

lh=legend('True','KDE','Gaussian','NP');
set(lh,'Location','SouthEast');

hold off;
save2pdf('nexp_ll.pdf',h2,300);

h4=figure('visible','off');
hold on;

boxplot(nnz_nexp','symbol','','colors','k','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(nnz_nexp'),'k-','LineWidth',2);

boxplot(nnz_bexp','symbol','','colors','b','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(nnz_bexp'),'b-.','LineWidth',2);

boxplot(nnz_texp','symbol','','colors','g','widths',0.4); 
set(gca,'XTickLabel',{' '});
plot(median(nnz_texp'),'g:','LineWidth',2);

xlabel('n');
ylabel('nnz');

set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10]);
set(gca,'XTickLabel',{'100','200','300','400','500','600','700','800','900','1000'})
    
title('NNZ');

lh=legend('Normal','Mixed Normal','t');
set(lh,'Location','East');

hold off;
save2pdf('nnz.pdf',h4,300);

