total_N=10;
total_R=20;

ll_true=zeros(total_N,total_R);
ll_KDE=zeros(total_N,total_R);
ll_GMM=zeros(total_N,total_R);
ll_NP=zeros(total_N,total_R);
ll_MSNP=zeros(total_N,total_R);
nnz_NP=zeros(total_N,total_R);
nnz_MSNP=zeros(total_N,total_R);

for i=1:10
    for j=1:20
        ki=i*100;
	[loglik,nnz]=extractlogliknr(ki,j,'../bexp_fixd/gmm/','_bexp.den');
	ll_true(i,j)=loglik(1);
	ll_KDE(i,j)=loglik(2);
	ll_GMM(i,j)=loglik(3);
	ll_NP(i,j)=loglik(4);
        ll_MSNP(i,j)=loglik(5);
        nnz_NP(i,j)=nnz(4);
        nnz_MSNP(i,j)=nnz(5);

    end
end

h1=figure(1);
hold on;
minll=min(min([ll_KDE;ll_GMM;ll_NP;ll_MSNP]))-500;
maxll=max(max(ll_true))+500;
x=100:100:1000;

boxplot(ll_true','symbol','','colors','k','widths',0.4); 
set(gca,'XTickLabel',{' '});
hleg1=plot(median(ll_true'),'k-','LineWidth',2);

boxplot(ll_KDE','symbol','','colors','b','widths',0.4);
set(gca,'XTickLabel',{' '}); 
hleg2=plot(median(ll_KDE'),'b-.','LineWidth',2);

boxplot(ll_GMM','symbol','','colors','g','widths',0.4); 
set(gca,'XTickLabel',{' '});
hleg3=plot(median(ll_GMM'),'g:','LineWidth',2);

boxplot(ll_NP','symbol','','colors','r','widths',0.4); 
set(gca,'XTickLabel',{' '});
hleg4=plot(median(ll_NP'),'r--','LineWidth',2);

boxplot(ll_MSNP','symbol','','colors','m','widths',0.4); 
set(gca,'XTickLabel',{' '});
hleg5=plot(median(ll_MSNP'),'m--','LineWidth',2);

axis([0.5,10.5,minll,maxll]);

xlabel('n');
ylabel('Out-of-sample log-likelihood');

set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10]);
set(gca,'XTickLabel',{'100','200','300','400','500','600','700','800','900','1000'})
    
title('Fitting Mixed-Normal Distribution');

lh=legend([hleg1,hleg2,hleg3,hleg4,hleg5],'True','KDE','GMM','NP','MSNP');
set(lh,'Location','SouthEast');

hold off;
save2pdf('ll.pdf',h1,300);


