function [ll,densitys,phat]=testopdatan(n,r,inpath)

data_train=csvread([inpath,'opdata/','opdata_n',num2str(n),'_r',num2str(r),'_texp.csv']);
data_test=csvread([inpath,'opdata/','opdata_testn',num2str(n),'_r',num2str(r),'_texp.csv']);

phat=mle(data_train,'distribution','tlocationscale');

mu=phat(1);
sigma=phat(2);
v=phat(3);

ll=0;
for i=1:size(data_test,1)
    ll=ll+log(1/sigma*tpdf((data_test(i)-mu)/sigma,v));
end

densitys=dlmread([inpath,'wsg_n',num2str(n),'_r',num2str(r),'_texp.den']);
for i=1:size(densitys,1)
    densitys(i,4)=1/sigma*tpdf((densitys(i,1)-mu)/sigma,v);
end

dlmwrite([inpath,'fitt/wsg_n',num2str(n),'_r',num2str(r),'_texp.den'],densitys,'delimiter',' ','precision',6);

loglikstxt=dlmread([inpath,'loglik_n',num2str(n),'_r',num2str(r),'_texp.den']);
loglikstxt(4)=ll;

dlmwrite([inpath,'fitt/loglik_n',num2str(n),'_r',num2str(r),'_texp.den'],loglikstxt,'precision',6);

